Package net.sf.saxon.value

## Class EmptySequence<T extends Item>

- java.lang.Object
- - net.sf.saxon.value.EmptySequence<T>

- All Implemented Interfaces:
    `GroundedValue`, `Sequence`

      public final class EmptySequence<T extends Item>
      extends java.lang.Object
      implements GroundedValue

  An EmptySequence object represents a sequence containing no members.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `java.util.Collections` | `a` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Item` | `asItem()` | Return the value in the form of an Item
    `boolean` | `effectiveBooleanValue()` | Get the effective boolean value - always false
    `boolean` | `equals​(java.lang.Object other)` | Is this expression the same as another expression?
    `static <T extends Item> EmptySequence<T>` | `getInstance()` | Get the implicit instance of this class
    `int` | `getLength()` | Get the length of the sequence
    `java.lang.String` | `getStringValue()` | Get the string value of this sequence.
    `java.lang.CharSequence` | `getStringValueCS()` | Get the string value of this sequence.
    `int` | `hashCode()` |
    `T` | `head()` | Get the first item in the sequence.
    `T` | `itemAt​(int n)` | Get the n'th item in the sequence (starting from 0).
    `UnfailingIterator` | `iterate()` | Return an iteration over the sequence
    `GroundedValue` | `reduce()` | Reduce the sequence to its simplest form.
    `GroundedValue` | `subsequence​(int min, int length)` | Get a subsequence of the value
    `java.lang.String` | `toString()` | Returns a string representation of the object.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, materialize, toShortString`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

- - ### Field Detail

    - #### a

          public java.util.Collections a

  - ### Method Detail

    - #### getInstance

          public static <T extends Item> EmptySequence<T> getInstance()

      Get the implicit instance of this class
      Returns:
        the singular instances of this class: an empty sequence

    - #### getStringValue

          public java.lang.String getStringValue()

      Description copied from interface: `GroundedValue`
      Get the string value of this sequence. The string value of an item is the result of applying the string() function. The string value of a sequence is the space-separated result of applying the string-join() function using a single space as the separator
      Specified by:
        `getStringValue` in interface `GroundedValue`
      Returns:
        the string value of the sequence.

    - #### getStringValueCS

          public java.lang.CharSequence getStringValueCS()

      Description copied from interface: `GroundedValue`
      Get the string value of this sequence. The string value of an item is the result of applying the string() function. The string value of a sequence is the space-separated result of applying the string-join() function using a single space as the separator
      Specified by:
        `getStringValueCS` in interface `GroundedValue`
      Returns:
        the string value of the sequence.

    - #### head

          public T head()

      Get the first item in the sequence.
      Specified by:
        `head` in interface `GroundedValue`
      Specified by:
        `head` in interface `Sequence`
      Returns:
        the first item in the sequence if there is one, or null if the sequence is empty

    - #### iterate

          public UnfailingIterator iterate()

      Return an iteration over the sequence
      Specified by:
        `iterate` in interface `GroundedValue`
      Specified by:
        `iterate` in interface `Sequence`
      Returns:
        an iterator (meaning a Saxon `SequenceIterator` rather than a Java `Iterator`) over all the items in this Sequence.

    - #### asItem

          public Item asItem()

      Return the value in the form of an Item
      Returns:
        the value in the form of an Item

    - #### getLength

          public final int getLength()

      Get the length of the sequence
      Specified by:
        `getLength` in interface `GroundedValue`
      Returns:
        always 0 for an empty sequence

    - #### equals

          public boolean equals​(java.lang.Object other)

      Is this expression the same as another expression?
      Overrides:
        `equals` in class `java.lang.Object`
      Throws:
        `java.lang.ClassCastException` - if the values are not comparable

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### effectiveBooleanValue

          public boolean effectiveBooleanValue()

      Get the effective boolean value - always false
      Specified by:
        `effectiveBooleanValue` in interface `GroundedValue`
      Returns:
        the effective boolean value

    - #### itemAt

          public T itemAt​(int n)

      Get the n'th item in the sequence (starting from 0). This is defined for all Values, but its real benefits come for a sequence Value stored extensionally (or for a MemoClosure, once all the values have been read)
      Specified by:
        `itemAt` in interface `GroundedValue`
      Parameters:
        `n` - position of the required item, counting from zero.
      Returns:
        the n'th item in the sequence, where the first item in the sequence is numbered zero. If n is negative or >= the length of the sequence, returns null.

    - #### subsequence

          public GroundedValue subsequence​(int min,
                                           int length)

      Get a subsequence of the value
      Specified by:
        `subsequence` in interface `GroundedValue`
      Parameters:
        `min` - the index of the first item to be included in the result, counting from zero. A negative value is taken as zero. If the value is beyond the end of the sequence, an empty sequence is returned
        `length` - the number of items to be included in the result. Specify Integer.MAX_VALUE to get the subsequence up to the end of the base sequence. If the value is negative, an empty sequence is returned. If the value goes off the end of the sequence, the result returns items up to the end of the sequence
      Returns:
        the required subsequence. If min is

    - #### toString

          public java.lang.String toString()

      Returns a string representation of the object.
      Overrides:
        `toString` in class `java.lang.Object`

    - #### reduce

          public GroundedValue reduce()

      Reduce the sequence to its simplest form. If the value is an empty sequence, the result will be EmptySequence.getInstance(). If the value is a single atomic value, the result will be an instance of AtomicValue. If the value is a single item of any other kind, the result will be an instance of SingletonItem. Otherwise, the result will typically be unchanged.
      Specified by:
        `reduce` in interface `GroundedValue`
      Returns:
        the simplified sequence